import { IComponentContext } from './context.service';
import { iInputs } from '../interface';
export default class Component {
    protected id: string;
    protected $$context: IComponentContext;
    state: any;
    constructor(id?: string, context?: IComponentContext);
    init(): Promise<void>;
    save(): Promise<void>;
    credentials(input: iInputs): Promise<void>;
    args(args: any, boolList?: [], moreList?: [], argsList?: []): {
        Commands: any;
        Parameters: any;
    };
    help(inputs: any, message: any): void;
    zip(packToParame: any): Promise<any>;
    /**
     * @description 主要的方法，用于load组件。
     * 组件会下载到 ~/.s/components 目录下面
     * @param name 组件名，注册在应用市场的组件
     * @param componentAlias 组件别名
     * @param provider SERVERLESS厂商
     */
    load(name: string, componentAlias?: string, provider?: string): Promise<any>;
}
