var utils_1 = require('../libs/utils');
var common_1 = require('../libs/common');
var path = require('path');
var fs = require('fs');
var ContextService = (function () {
    function ContextService(context) {
        if (context === void 0) { context = {}; }
        this.credentials = {};
        this.async = init();
        var stateFileRoot = context.stateFileRoot, componentPathRoot = context.componentPathRoot;
        var currentSDir = path.join(process.cwd(), '.s');
        this.componentPathRoot = componentPathRoot ? path.resolve(componentPathRoot) : common_1.S_ROOT_HOME_COMPONENT;
        if (!stateFileRoot && !fs.existsSync(currentSDir)) {
            fs.mkdirSync(currentSDir);
        }
        this.stateFileRoot = stateFileRoot ? path.resolve(stateFileRoot) : currentSDir;
        this.credentials = context.credentials || {};
        this.id = utils_1.uuid();
        this.state = { id: this.id };
    }
    return ContextService;
})();
exports["default"] = ContextService;
{
    var contextStatePath = path.join(this.stateFileRoot, 'identify_.json');
    if (fs.existsSync(contextStatePath)) {
        this.state = utils_1.readJsonFile(contextStatePath);
    }
    else {
        utils_1.writeJsonFile(contextStatePath, this.state);
    }
    this.id = this.state.id;
}
async;
getState(id, string);
{
    var stateFilePath = path.join(this.stateFileRoot, id + ".json");
    var result = {};
    if (fs.existsSync(stateFilePath)) {
        result = utils_1.readJsonFile(stateFilePath);
    }
    return result;
}
async;
setState(id, string, state, any);
{
    var stateFilePath = path.join(this.stateFileRoot, id + ".json");
    if (!fs.existsSync(stateFilePath)) {
        fs.openSync(stateFilePath, 'w');
    }
    fs.writeFileSync(stateFilePath, JSON.stringify(state, null, 2), 'utf-8');
    return state;
}
