var utils_1 = require('../libs/utils');
var addAccess_1 = require('../libs/addAccess');
var common_1 = require('../libs/common');
var inquirer = require('inquirer');
var fs = require('fs-extra');
var yaml = require('js-yaml');
var CREATE_ACCESS = '_create';
async;
function getAccessInfo(Project, filePath) {
    var isExist = fs.existsSync(filePath);
    var userAccessInfo = {};
    if (!isExist) {
        return userAccessInfo;
    }
    var userInformation = yaml.safeLoad(fs.readFileSync(filePath, 'utf8'));
    if (userInformation) {
        var Provider = Project.Provider;
        var AccessAlias = Project.AccessAlias;
        if (Provider) {
            var provider = Provider.toLocaleLowerCase();
            if (AccessAlias) {
                var accessAlias = provider + "." + AccessAlias;
                userAccessInfo = utils_1.omitObject(userInformation, function (value, key) { return key === accessAlias; });
            }
            else {
                userAccessInfo = utils_1.omitObject(userInformation, function (value, key) { return key.split('.')[0] === provider; });
            }
        }
    }
    return userAccessInfo;
}
/**
 * @description access访问权限提示
 * @param Provider
 * @param userAccessInfo
 */
async;
function getAccessPrompt(Provider, userAccessInfo) {
    var selectAccessList = utils_1.map(userAccessInfo, function (value, key) { return ({
        name: "" + key.replace(Provider + ".", Provider + ": "),
        value: key
    }); });
    selectAccessList.push({ name: 'Create a new account', value: CREATE_ACCESS });
    var access = await.access, inquirer;
    prompt([
        {
            type: 'list',
            name: 'access',
            message: 'Please select an access:',
            choices: selectAccessList
        },
    ]);
    return access;
}
async;
function credentials(inputs) {
    var Project = inputs.Project;
    var Provider = Project.Provider;
    var userAccessInfo = await, getAccessInfo = (Project, common_1.S_ROOT_HOME_ACCESS);
    var access = await, getAccessPrompt = (Provider, userAccessInfo);
    if (access === CREATE_ACCESS) {
        var addManager = new addAccess_1.AddManager();
        var result = await, addManager, inputLengthZero = (Provider);
        // 2020-9-23 修复部署过程中增加密钥信息，无法存储到系统的bug
        var inputProviderAlias = Provider + "." + (addManager.aliasName || 'default');
        addManager.inputFullData[inputProviderAlias] = result;
        addManager.writeData(addManager.globalFilePath, addManager.inputFullData);
        return result;
    }
    return userAccessInfo[access];
}
