/**
 * @description 用于存放工具函数
 */
var secure_1 = require('uid/secure');
var fs = require('fs-extra');
/* eslint-disable @typescript-eslint/no-use-before-define */
exports.isUndefined = function (obj) { return typeof obj === 'undefined'; };
exports.isObject = function (fn) { return !exports.isNil(fn) && typeof fn === 'object'; };
exports.isPlainObject = function (fn) {
    if (!exports.isObject(fn)) {
        return false;
    }
    var proto = Object.getPrototypeOf(fn);
    if (proto === null) {
        return true;
    }
    var ctor = Object.prototype.hasOwnProperty.call(proto, 'constructor') && proto.constructor;
    return (typeof ctor === 'function' &&
        ctor instanceof ctor &&
        Function.prototype.toString.call(ctor) === Function.prototype.toString.call(Object));
};
exports.isFunction = function (fn) { return typeof fn === 'function'; };
exports.isString = function (fn) { return typeof fn === 'string'; };
exports.isConstructor = function (fn) { return fn === 'constructor'; };
exports.isNil = ;
null | undefined;
exports.isUndefined(obj) || obj === null;
exports.isEmpty = function (array) { return !(array && array.length > 0); };
exports.isSymbol = function (fn) { return typeof fn === 'symbol'; };
// TODO: add types
exports.omitObject = function (object, callback) {
    var newObj = {};
    for (var key in object) {
        var value = object[key];
        if (callback(value, key)) {
            newObj[key] = value;
        }
    }
    return newObj;
};
exports.map = function (object, callback) {
    var newList = [];
    for (var key in object) {
        var value = object[key];
        newList.push(callback(value, key));
    }
    return newList;
};
exports.uuid = secure_1.uid;
function readJsonFile(filePath) {
    var result = {};
    var data = fs.readFileSync(filePath, 'utf8');
    try {
        result = JSON.parse(data);
    }
    catch (e) {
    }
    return result;
}
exports.readJsonFile = readJsonFile;
function writeJsonFile(filePath, data) {
    fs.writeFileSync(filePath, JSON.stringify(data, null, 2), 'utf-8');
}
exports.writeJsonFile = writeJsonFile;
